﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using CameraControlLibrary;
using Windows.Devices.Sensors;
using Windows.Foundation;
using Windows.Foundation.Collections;
using Windows.UI.Core;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Controls.Primitives;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Input;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Navigation;


// The Blank Page item template is documented at http://go.microsoft.com/fwlink/?LinkId=234238

namespace GadgeteerRobot.W8
{
    /// <summary>
    /// An empty page that can be used on its own or navigated to within a Frame.
    /// </summary>
    public sealed partial class MainPage : Page
    {
        private RobotControl rb;

        private Accelerometer accelerometer;

        public MainPage()
        {
            this.InitializeComponent();
            rb = new RobotControl();

            accelerometer = Accelerometer.GetDefault();

            if (accelerometer != null)
            {
                accelerometer.ReadingChanged += (obj, args) =>
                {
                    double x = args.Reading.AccelerationX;
                    double y = args.Reading.AccelerationY;

                    if (x > 0.5)
                        x = 0.5;
                    else if (x < -0.5)
                        x = -0.5;
                    if (y > 0.5)
                        y = 0.5;
                    else if (y < -0.5)
                        y = -0.5;

                    Dispatcher.RunAsync(CoreDispatcherPriority.High, () =>
                    {
                        Sliding.X = x * (180 - Circle.Width);
                        Sliding.Y = -y * (180 - Circle.Height);
                        lbl1.Text = Sliding.X.ToString();
                        lbl2.Text = Sliding.Y.ToString();
                        //txtX.Text = args.Reading.AccelerationX.ToString();
                        //txtY.Text = args.Reading.AccelerationY.ToString();
                        if (Sliding.X > 20)
                        {
                            txtX.Text = "Destra";
                            rb.TurnRight();
                        }
                        else if (Sliding.X < -20)
                        {
                            txtX.Text = "Sinistra";
                            rb.TurnLeft();
                        }
                        if (Sliding.Y > 20)
                        {
                            txtY.Text = "Giu";
                            rb.MoveBackward();
                        }
                        else if (Sliding.Y < -20)
                        {
                            txtY.Text = "Su";
                            rb.MoveForeward();
                        }

                    });
                };
            }

        }

        /// <summary>
        /// Invoked when this page is about to be displayed in a Frame.
        /// </summary>
        /// <param name="e">Event data that describes how this page was reached.  The Parameter
        /// property is typically used to configure the page.</param>
        protected override async void OnNavigatedTo(NavigationEventArgs e)
        {
            lbl1.Text = "Connessione in corso ...";
            await rb.ConnectAsync("192.168.0.101:8080", null);
            lbl1.Text = "Connesso";
        }

        private void btnSu_Click(object sender, RoutedEventArgs e)
        {
            rb.MoveForeward();
        }

        private void btnGiu_Click(object sender, RoutedEventArgs e)
        {
            rb.MoveBackward();
        }

        private void btnDx_Click(object sender, RoutedEventArgs e)
        {
            rb.TurnRight();
        }

        private void btnSx_Click(object sender, RoutedEventArgs e)
        {
            rb.TurnLeft();
        }

        private void btnOn_Click(object sender, RoutedEventArgs e)
        {
            rb.MotorOn();
            lblMsg1.Text = "Motore acceso";
        }

        private void btnOff_Click(object sender, RoutedEventArgs e)
        {
            rb.MotorOff();
            lblMsg1.Text = "Motore Spento";
        }

        private void btnRot_Click(object sender, RoutedEventArgs e)
        {
            rb.Rotate();
        }

        private void btnStop_Click(object sender, RoutedEventArgs e)
        {
            rb.Stop();
            lblMsg1.Text = "Stop";
        }

    }
}
