/* Copyright 2012 Marco Minerva, marco.minerva@gmail.com

   Licensed under the Apache License, Version 2.0 (the "License");
   you may not use this file except in compliance with the License.
   You may obtain a copy of the License at

       http://www.apache.org/licenses/LICENSE-2.0

   Unless required by applicable law or agreed to in writing, software
   distributed under the License is distributed on an "AS IS" BASIS,
   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   See the License for the specific language governing permissions and
   limitations under the License.
*/

using System;
using Microsoft.SPOT;

namespace GadgeteerRobot
{
    public class RobotCommands
    {
        public const string TURN_ON = "turn_on";
        public const string TURN_OFF = "turn_off";
        public const string SET_SPEED = "set_speed";
        public const string MOVE_FORWARD = "f";
        public const string MOVE_BACKWARD = "b";
        public const string TURN_LEFT = "l";
        public const string TURN_RIGHT = "r";
        public const string ROTATE = "t";
        public const string STOP = "s";

        public const string GET_IMAGE = "c";
        public const string CENTER_CAMERA = "center_camera";
        public const string CAMERA_LEFT = "camera_left";
        public const string CAMERA_RIGHT = "camera_right";
    }

    /// <summary>
    /// The <strong>Direction</strong> enum defines the direction to which the camera can be rotated.
    /// </summary>
    public enum ServoDirection
    {
        /// <summary>
        /// Turns the camera on the left.
        /// </summary>
        Left,
        /// <summary>
        /// Turns the camera on the right.
        /// </summary>
        Right
    }
}
