﻿Imports Microsoft.Kinect

Public Class ReferenceArea

    Public Property Name As String
    Public Property Type As ReferenceAreaType

    Public Property X1 As Double
    Public Property X2 As Double
    Public Property Y1 As Double
    Public Property Y2 As Double
    Public Property Z1 As Double = 0
    Public Property Z2 As Double = Double.MaxValue

    Public ReadOnly Property Width As Double
        Get
            Return Math.Abs(X1 - X2)
        End Get
    End Property

    Public ReadOnly Property Height As Double
        Get
            Return Math.Abs(Y1 - Y2)
        End Get
    End Property

    Public ReadOnly Property Depth As Double
        Get
            Return Math.Abs(Z1 - Z2)
        End Get
    End Property

    Public Function IsInArea(x As Double, y As Double, z As Double) As Boolean
        Dim retval As Boolean = True
        retval = retval And (x >= X1 And x <= X2)
        retval = retval And (y >= Y1 And y <= Y2)
        retval = retval And (z >= Z1 And z <= Z2)
        Return retval
    End Function

    Public Function IsInArea(point As skeletonpoint) As Boolean
        Return IsInArea(point.X, point.Y, point.Z)
    End Function

    Public Function IsInArea(colorPoint As ColorImagePoint, z As Double, imageWidth As Integer, imageHeight As Integer) As Boolean
        Dim x = 2 * colorPoint.X / imageWidth - 1
        Dim y = -2 * colorPoint.Y / imageHeight + 1
        Return IsInArea(x, y, z)
    End Function
End Class
