﻿
Imports KinectManager.Core

Namespace Common

    Public NotInheritable Class ReferenceAreaConverter
        Implements IValueConverter


        Public Function Convert(value As Object,
                                targetType As System.Type,
                                parameter As Object,
                                culture As System.Globalization.CultureInfo) As Object Implements System.Windows.Data.IValueConverter.Convert
            If TypeOf value Is ReferenceArea AndAlso TypeOf parameter Is String Then
                Dim referenceArea = CType(value, ReferenceArea)
                Dim coord = parameter.ToString().Split(";"c)(0)
                Dim dimension = CInt(parameter.ToString().Split(";"c)(1))
                Select Case coord.ToUpper()
                    Case "X1"
                        Return (referenceArea.X1 + 1D) * dimension / 2D
                    Case "X2"
                        Return (referenceArea.X2 + 1D) * dimension / 2D
                    Case "Y1"
                        Return (-referenceArea.Y1 + 1D) * dimension / 2D
                    Case "Y2"
                        Return (-referenceArea.Y2 + 1D) * dimension / 2D
                    Case "WIDTH"
                        Return referenceArea.Width * dimension / 2D
                    Case "HEIGHT"
                        Return referenceArea.Height * dimension / 2D
                End Select
            End If
            Return Nothing
        End Function

        Public Function ConvertBack(value As Object, targetType As System.Type, parameter As Object, culture As System.Globalization.CultureInfo) As Object Implements System.Windows.Data.IValueConverter.ConvertBack
            Throw New NotImplementedException()
        End Function
    End Class

End Namespace
