﻿Imports Microsoft.Kinect
Imports KinectManager.Core
Imports Coding4Fun.Kinect.Wpf

Namespace Common

    Public NotInheritable Class SkeletonJointPositionConverter
        Implements IValueConverter


        Public Function Convert(value As Object,
                                targetType As System.Type,
                                parameter As Object,
                                culture As System.Globalization.CultureInfo) As Object Implements System.Windows.Data.IValueConverter.Convert
            If TypeOf value Is Skeleton AndAlso TypeOf parameter Is String Then
                Dim skeleton = CType(value, Skeleton)
                Dim parameters = parameter.ToString().Split(";"c)
                ' parameters(0) -> JointType
                Dim jointType = CType([Enum].Parse(GetType(JointType), parameters(0)), JointType)
                Dim joint = skeleton.Joints(jointType)
                If joint.TrackingState = JointTrackingState.Tracked Then
                    ' parameters(2) -> width immagine
                    Dim width = CInt(parameters(2))
                    ' parameters(3) -> height immagine
                    Dim height = CInt(parameters(3))
                    ' parameters(1) -> X o Y
                    Dim scaledJoint = joint.ScaleTo(width, height, 1.0F, 1.0F)
                    Select Case parameters(1).ToUpper()
                        Case "X"
                            Return scaledJoint.Position.X
                        Case "Y"
                            Return scaledJoint.Position.Y
                        Case Else
                            Return 0
                    End Select
                End If
            End If
            Return 0
        End Function

        Public Function ConvertBack(value As Object, targetType As System.Type, parameter As Object, culture As System.Globalization.CultureInfo) As Object Implements System.Windows.Data.IValueConverter.ConvertBack
            Throw New NotImplementedException()
        End Function
    End Class

End Namespace
