﻿
Imports Microsoft.Practices.Unity
Imports KinectManager.WPF.Utilities

Namespace ViewModels

    Public NotInheritable Class ViewModelLocator

        Public Sub New()
            _container = New Lazy(Of IUnityContainer)(AddressOf IoCUtility.BuildContainer)
        End Sub

        Private _container As Lazy(Of IUnityContainer)
        Public ReadOnly Property Container As IUnityContainer
            Get
                Return _container.Value
            End Get
        End Property


        Public ReadOnly Property GadgeteerWindowViewModel As GadgeteerWindowViewModel
            Get
                Dim paramOverrides = New ParameterOverrides()
                paramOverrides.Add("container", Container)
                Dim vm = Container.Resolve(Of GadgeteerWindowViewModel)(paramOverrides)
                Return vm
            End Get
        End Property
    End Class
End Namespace