﻿
Imports GadgeteerManager

Public Class GadgeteerControl
    Implements IRobotControl

    Private _Form As MainForm
    Private _Status As Status = Status.Stopped

    Public Sub ChangeSpeed(speed As Integer) Implements GadgeteerManager.IRobotControl.ChangeSpeed
        Throw New NotImplementedException
    End Sub

    Public Sub Connect(address As String, password As String) Implements GadgeteerManager.IRobotControl.Connect
        _Form = New MainForm()
        _Form.Show()
        SetFormStatus(Me._Status)
    End Sub

    Public Sub Disconnect() Implements GadgeteerManager.IRobotControl.Disconnect
        _Form.Close()
    End Sub

    Public Sub MotorOff() Implements GadgeteerManager.IRobotControl.MotorOff
        Me._Status = Status.Stopped
        SetFormStatus(Me._Status)
    End Sub

    Public Sub MotorOn() Implements GadgeteerManager.IRobotControl.MotorOn
        Me._Status = Status.Started
        SetFormStatus(Me._Status)
    End Sub

    Public Sub MoveBackward() Implements GadgeteerManager.IRobotControl.MoveBackward
        If (Me._Status And Status.Started) > 0 Then
            Me._Status = Status.Started Or Status.Backward
            SetFormStatus(Me._Status)
        End If

    End Sub

    Public Sub MoveBackwardLeft() Implements GadgeteerManager.IRobotControl.MoveBackwardLeft
        If (Me._Status And Status.Started) > 0 Then
            Me._Status = Status.Started Or Status.Backward Or Status.TurnLeft
            SetFormStatus(Me._Status)
        End If
    End Sub

    Public Sub MoveBackwardRight() Implements GadgeteerManager.IRobotControl.MoveBackwardRight
        If (Me._Status And Status.Started) > 0 Then
            Me._Status = Status.Started Or Status.Backward Or Status.TurnRight
            SetFormStatus(Me._Status)
        End If
    End Sub

    Public Sub MoveForeward() Implements GadgeteerManager.IRobotControl.MoveForeward
        If (Me._Status And Status.Started) > 0 Then
            Me._Status = Status.Started Or Status.Foreward
            SetFormStatus(Me._Status)
        End If
    End Sub

    Public Sub MoveForewardLeft() Implements GadgeteerManager.IRobotControl.MoveForewardLeft
        If (Me._Status And Status.Started) > 0 Then
            Me._Status = Status.Started Or Status.Foreward Or Status.TurnLeft
            SetFormStatus(Me._Status)
        End If
    End Sub

    Public Sub MoveForewardRight() Implements GadgeteerManager.IRobotControl.MoveForewardRight
        If (Me._Status And Status.Started) > 0 Then
            Me._Status = Status.Started Or Status.Foreward Or Status.TurnRight
            SetFormStatus(Me._Status)
        End If
    End Sub

    Public Sub Rotate() Implements GadgeteerManager.IRobotControl.Rotate
        Throw New NotImplementedException
    End Sub

    Public Sub [Stop]() Implements GadgeteerManager.IRobotControl.Stop
        Me._Status = Status.Started
        SetFormStatus(Me._Status)
    End Sub

    Public Sub TurnLeft() Implements GadgeteerManager.IRobotControl.TurnLeft
        If (Me._Status And Status.Started) > 0 Then
            Me._Status = Me._Status Or Status.TurnLeft
            SetFormStatus(Me._Status)
        End If
    End Sub

    Public Sub TurnRight() Implements GadgeteerManager.IRobotControl.TurnRight
        If (Me._Status And Status.Started) > 0 Then
            Me._Status = Me._Status Or Status.TurnRight
            SetFormStatus(Me._Status)
        End If
    End Sub

    Private Sub SetFormStatus(Status As Status)
        If _Form IsNot Nothing Then
            _Form.Status = Status
        End If
    End Sub

    Public Sub Ping() Implements IGadgeteerControl.Ping

    End Sub
End Class
