﻿Imports KinectManager.Core
Imports KinectManager.Core.EventArgs
Imports Microsoft.Kinect
Imports KinectManager.Core.Handlers

Namespace Handlers
    Public Class JointInAreaSkeletalTrackingHandler
        Inherits SkeletalTrackingHandlerBase

        Public Property JointType As JointType = JointType.Head

        Public Overrides Function Elaborate() As System.Collections.Generic.IEnumerable(Of Integer)
            If Me.KinectManager IsNot Nothing AndAlso Me.ReferenceAreas.Any(Function(a) a.Type = ReferenceAreaType.SkeletalTrackingArea) Then
                If Me.KinectManager.FrameBuffer.Any() Then
                    Dim lastSkeletons = Me.KinectManager.FrameBuffer.Last().Skeletons
                    If lastSkeletons IsNot Nothing Then
                        Dim areas = Me.ReferenceAreas.Where(Function(a) a.Type = ReferenceAreaType.SkeletalTrackingArea)
                        Dim skeleton = (From s In lastSkeletons
                                        Where (From a In areas
                                               Where a.IsInArea(s.Joints(JointType).Position)
                                               Select a).Any() _
                                        And s.TrackingState = SkeletonTrackingState.Tracked
                                        Select s).FirstOrDefault()
                        If skeleton IsNot Nothing Then
                            Dim trackingIdList = {skeleton.TrackingId}
                            Dim arg = New SkeletalTrackedEventArgs() With {.Timestamp = DateTime.Now, .Skeleton = skeleton}
                            OnSkeletalTracked(arg)                            
                            Return trackingIdList
                        End If
                    End If
                End If
            End If
            Return Nothing
        End Function
    End Class
End Namespace