﻿Public Class MainForm

    Private _Status As Status
    Property Status As Status
        Get
            Return _Status
        End Get
        Set(value As Status)
            Me._Status = value
            UpdateGUI()
        End Set
    End Property

    Private Delegate Sub UpdateGuiDelegate()
    Private Sub UpdateGUI()
        If Me.InvokeRequired Then
            Me.Invoke(New UpdateGuiDelegate(AddressOf UpdateGUI), Nothing)
        Else
            If (Me._Status And Kinecteer.Status.Stopped) > 0 Then
                pctCenter.Image = My.Resources.Stopped
                pctBackward.Image = Nothing
                pctForward.Image = Nothing
                pctLeft.Image = Nothing
                pctRight.Image = Nothing
            Else
                pctCenter.Image = My.Resources.Started
                If (Me._Status And Kinecteer.Status.Backward) > 0 Then
                    pctBackward.Image = My.Resources.Backward
                Else
                    pctBackward.Image = Nothing
                End If
                If (Me._Status And Kinecteer.Status.Foreward) > 0 Then
                    pctForward.Image = My.Resources.Forward
                Else
                    pctForward.Image = Nothing
                End If
                If (Me._Status And Kinecteer.Status.TurnLeft) > 0 Then
                    pctLeft.Image = My.Resources.Left
                Else
                    pctLeft.Image = Nothing
                End If
                If (Me._Status And Kinecteer.Status.TurnRight) > 0 Then
                    pctRight.Image = My.Resources.Right
                Else
                    pctRight.Image = Nothing
                End If

            End If
        End If


    End Sub

End Class