Namespace EventArgs
    ''' <summary>
    ''' Classe base degli argomenti degli eventi di cambiamento di stato.
    ''' </summary>
    ''' <remarks></remarks>
    Public Class StateChangeEventArgsBase
        Inherits System.EventArgs

        Private _Entity As Object

        ''' <summary>
        ''' Contiene l'istanza dell'entit della quale si sta eseguendo il cambiamento di stato.
        ''' </summary>
        ''' <value>The entity.</value>
        ''' <remarks></remarks>
        Public Property Entity() As Object
            Get
                Return Me._Entity
            End Get
            Set(ByVal value As Object)
                Me._Entity = value
            End Set
        End Property


        Private _Event As Object

        ''' <summary>
        ''' Contiene l'istanza dell'evento responsabile del cambiamento di stato.
        ''' </summary>
        ''' <value></value>
        ''' <returns></returns>
        ''' <remarks></remarks>
        Public Property [Event]() As Object
            Get
                Return Me._Event
            End Get
            Set(ByVal value As Object)
                Me._Event = value
            End Set
        End Property


        Private _EntityType As Type

        ''' <summary>
        ''' Contiene il tipo dell'entit della quale si sta eseguendo il cambiamento di stato.
        ''' </summary>
        ''' <value></value>
        ''' <returns></returns>
        ''' <remarks></remarks>
        Public Property EntityType() As Type
            Get
                Return Me._EntityType
            End Get
            Set(ByVal value As Type)
                Me._EntityType = value
            End Set
        End Property


        Private _EventType As Type

        ''' <summary>
        ''' Contiene il tipo dell'evento responsabile del cambiamento di stato.
        ''' </summary>
        ''' <value></value>
        ''' <returns></returns>
        ''' <remarks></remarks>
        Public Property EventType() As Type
            Get
                Return Me._EventType
            End Get
            Set(ByVal value As Type)
                Me._EventType = value
            End Set
        End Property


        Private _StateType As Type

        ''' <summary>
        ''' Contiene il tipo dello stato.
        ''' </summary>
        ''' <value></value>
        ''' <returns></returns>
        ''' <remarks></remarks>
        Public Property StateType() As Type
            Get
                Return Me._StateType
            End Get
            Set(ByVal value As Type)
                Me._StateType = value
            End Set
        End Property

    end class
End NameSpace