﻿Namespace EventArgs
    ''' <summary>
    ''' Argomento dell'evento <see cref="Implementations.StateMachineController.StateChanging">StateChanging</see> della classe <see cref="Implementations.StateMachineController">StateMachineController</see>.
    ''' </summary>
    ''' <remarks></remarks>
    Public Class StateChangingEventArgs
        Inherits StateChangeEventArgsBase

        Friend Sub New(ByVal args As StateChangeEventArgsBase)
            Me.Entity = args.Entity
            Me.EntityType = args.EntityType
            Me.Event = args.Event
            Me.EventType = args.EventType
            Me.StateType = args.StateType
        End Sub

        Private _Cancel As Boolean = False

        ''' <summary>
        ''' Permette di annullare l'operazione di cambiamento di stato.
        ''' </summary>
        ''' <value></value>
        ''' <returns></returns>
        ''' <remarks>Il valore di default è False.
        ''' Se viene impostato a True, la StateMachineController interrompe l'operazione del cambiamento di stato.
        ''' In caso di interruzione dell'operazione di cambiamento di stato non vengono sollevati gli eventi <see cref="Implementations.StateMachineController.StateChanged">StateChanged</see> e <see cref="Implementations.StateMachineController.StateChangeError">StateChangeError</see>.
        ''' Eventuali altri gestori di evento collegati all'evento non vengono richiamati.</remarks>
        Public Property Cancel() As Boolean
            Get
                Return Me._Cancel
            End Get
            Set(ByVal value As Boolean)
                Me._Cancel = value
            End Set
        End Property

    End Class
End Namespace